MAP

The MAP function returns an array formed by mapping each value in the array(s) to a new value by applying a LAMBDA to create a new value.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

Syntax

=MAP(array1, lambda_or_array<#>)

The MAP function syntax has the following arguments and parameters:

  • array1
    An array to be mapped.
  • lambdaorarray<#>
    A LAMBDA which must be the last argument and which must have either a parameter for each array passed, or another array to be mapped.

Tip

Before using this function, you need to turn on the allowDynamicArray option

var workbook = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
workbook.options.allowDynamicArray = true;

Basic Usage

Square numbers above a certain value

sheet.setFormula(0, 0, 'MAP(A1:C2, LAMBDA(a, IF(a>4,a*a,+a)))');
// A1:C2 is      result is
// 1 2 3         1 2  3
// 4 5 6         4 25 36

Find values from two columns in one row that are both TRUE

sheet.setFormula(0, 0, 'MAP(A1:A4, B1:B4, LAMBDA(a,b,AND(a,b)))');
// A1:B4 is      result is
// TRUE  TRUE    TRUE
// TRUE  FALSE   FALSE
// FALSE TRUE    FALSE
// FALSE FALSE   FALSE
Syntax The MAP function syntax has the following arguments and parameters: array1 An array to be mapped. lambdaorarray<#> A LAMBDA which must be the last argument and which must have either a parameter for each array passed, or another array to be mapped. Tip Before using this function, you need to turn on the allowDynamicArray option Basic Usage Square numbers above a certain value Find values from two columns in one row that are both TRUE
var data = { values: { 1: { 1: "Examples" }, 3: { 1: "Example 1: Square numbers above a vertain value" }, 4: { 1: "Data:", 5: "Formula:" }, 5: { 1: 1, 2: 2, 3: 3, 5: "Result:" }, 6: { 1: 4, 2: 5, 3: 6 }, 7: { 5: "Calculating the last LAMBDA parameter as a*1 coerces it to an integer and prevents a #CALC! error.", }, 10: { 1: "Example 2: Find values from two columns in one row that are both TRUE" }, 11: { 1: "TableA:" }, 12: { 1: "Col1", 2: "Col2", 5: "Formula:" }, 13: { 1: false, 2: true, 5: "Result:" }, 14: { 1: false, 2: true }, 15: { 1: true, 2: true }, 16: { 1: false, 2: false }, 17: { 1: false, 2: true }, 18: { 1: true, 2: false }, 19: { 1: true, 2: true }, 20: { 1: true, 2: false }, 23: { 1: "Example 3: Find values from two columns in one row that meet certain criteria" }, 24: { 1: "TableB:" }, 25: { 1: "Size", 2: "Color", 5: "Formula:" }, 26: { 1: "Medium", 2: "Red" }, 27: { 1: "Large", 2: "Green", 6: "Valid Size", 7: "Valid Color" }, 28: { 1: "Medium", 2: "Blue", 5: "Result:" }, 29: { 1: "Medium", 2: "Blue" }, 30: { 1: "Medium", 2: "Red" }, 31: { 1: "Large", 2: "Red" }, 32: { 1: "Medium", 2: "Blue" }, 33: { 1: "Small", 2: "Blue" }, 34: { 1: "Medium", 2: "Green" }, 35: { 1: "Large", 2: "Green" }, }, formulas: { 4: { 6: "FORMULATEXT(G6)" }, 5: { 6: "MAP(B6:D7,LAMBDA(a,IF(a>4,a*a,a*1)))" }, 12: { 6: "FORMULATEXT(G14)" }, 13: { 6: "MAP(TableA[Col1],TableA[Col2],LAMBDA(a,b,AND(a,b)))" }, 25: { 6: "FORMULATEXT(G29)" }, 28: { 6: 'FILTER(TableB,MAP(TableB[Size],TableB[Color],LAMBDA(s,c,AND(s="Large",c="Red"))))' }, }, cellStyles: { "B2:C2": 0, "B4:G4": 1, B5: 2, C5: 3, D5: 4, "F5:F6": 2, "G5:I7": 5, "J5:K5": 5, "B6:D7": 6, "F8:K9": 7, "B11:I11": 1, "B12:C12": 8, "F13:F14": 2, "G13:G21": 5, "H13:L13": 5, "B24:J24": 1, "B25:C25": 8, F26: 2, "G26:K27": 9, "G28:H28": 2, F29: 2, "G29:H29": 5, }, styles: { records: [ { foreColor: 0, font: 0, border: [null, null, 0] }, { foreColor: 0, font: 1, border: [null, null, 1] }, { backColor: 2, foreColor: 1, font: 1, border: [2, null, 3, 4] }, { backColor: 2, foreColor: 1, font: 1, border: [2, null, 3] }, { backColor: 2, foreColor: 1, font: 1, border: [2, 4, 3] }, { backColor: 4, foreColor: 3, font: 1, border: [3, 3, 3, 3] }, { backColor: 6, foreColor: 5, border: [3, 3, 3, 3] }, { backColor: 7, wordWrap: true, border: [5, 5, 5, 5] }, { foreColor: 0, font: 1 }, { backColor: 4, foreColor: 3, font: 1, wordWrap: true, border: [3, 3, 3, 3] }, ], borders: [ { color: "#accdea", style: 5 }, { color: "#9bc3e6", style: 2 }, { color: "#000000", style: 1 }, { color: "#7f7f7f", style: 1 }, { color: "#9bc3e6", style: 1 }, { color: "#b2b2b2", style: 1 }, ], colors: ["#44546a", "#ffffff", "#5b9bd5", "#fa7d00", "#f2f2f2", "#3f3f76", "#ffcc99", "#ffffcc"], fonts: ["700 17.3px Calibri", "700 14.7px Calibri"], }, others: { columnWidth: { 0: 30 }, rowHeight: { 1: 24, 2: 21, 3: 21, 10: 21, 23: 21 }, spans: ["B5:D5", "F8:K9", "G26:K27"], tables: [ { name: "TableA", ref: "B13:C21" }, { name: "TableB", ref: "B26:C36" }, ], }, }; window.onload = function () { var workbook = new GC.Spread.Sheets.Workbook(document.getElementById("ss")); workbook.options.allowDynamicArray = true; workbook.suspendPaint(); initSheet1(workbook.getSheet(0)); workbook.resumePaint(); }; function initSheet1(sheet) { setSheetPr(sheet); setCells(sheet); } function setCells(sheet) { foreachObj(data.values, function (r, row) { foreachObj(row, function (c, v) { setValue(sheet, Number(r), Number(c), v); }); }); foreachObj(data.formulas, function (r, row) { foreachObj(row, function (c, v) { setFormula(sheet, Number(r), Number(c), v); }); }); foreachObj(data.cellStyles, function (ref, id) { setStyle(sheet, ref, data.styles.records[id]); }); } function setValue(sheet, r, c, v) { if (v === undefined || v === null) return; sheet.setValue(r, c, v); } function setFormula(sheet, r, c, v) { if (v === undefined || v === null) return; sheet.setFormula(r, c, v); } function setStyle(sheet, ref, v) { if (v === undefined || v === null) return; var styles = data.styles; var range = sheet.getRange(ref); var foreColor = styles.colors[v.foreColor]; var backColor = styles.colors[v.backColor]; var font = styles.fonts[v.font]; var wordWrap = v.wordWrap; if (foreColor) { range.foreColor(foreColor); } if (backColor) { range.backColor(backColor); } if (font) { range.font(font); } if (wordWrap) { range.wordWrap(wordWrap); } var border = v.border || []; var borderTop = styles.borders[border[0]]; var borderRight = styles.borders[border[1]]; var borderBottom = styles.borders[border[2]]; var borderLeft = styles.borders[border[3]]; if (borderTop) { range.borderTop(createLineStyle(borderTop)); } if (borderBottom) { range.borderBottom(createLineStyle(borderBottom)); } if (borderLeft) { range.borderLeft(createLineStyle(borderLeft)); } if (borderRight) { range.borderRight(createLineStyle(borderRight)); } } function setSheetPr(sheet) { // set column width foreachObj(data.others.columnWidth, function (index, v) { sheet.setColumnWidth(Number(index), v); }); // set row height foreachObj(data.others.rowHeight, function (index, v) { sheet.setRowHeight(Number(index), v); }); // set spans var spans = data.others.spans || []; for (var i = 0; i < spans.length; i++) { var range = sheet.getRange(spans[i]); sheet.addSpan(range.row, range.col, range.rowCount, range.colCount); } // set tables var tables = data.others.tables || []; for (var i = 0; i < tables.length; i++) { var table = tables[i]; var range = sheet.getRange(table.ref); sheet.tables.add(table.name, range.row, range.col, range.rowCount, range.colCount); } } function createLineStyle(v) { return new GC.Spread.Sheets.LineBorder(v.color, v.style); } function foreachObj(obj, func) { if (!obj) return; var keys = Object.keys(obj); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var v = obj[key]; func(key, v); } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> </div> </body> </html>
input[type="text"] { width: 200px; margin-right: 20px; } label { display: inline-block; width: 110px; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } label { display: block; margin-bottom: 6px; } input { padding: 4px 6px; } input[type=button] { margin-top: 6px; display: block; width:216px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } code { border: 1px solid #000; }

Syntax
The MAP function syntax has the following arguments and parameters:
array1
An array to be mapped.
lambdaorarray<#>
A LAMBDA which must be the last argument and which must have either a parameter for each array passed, or another array to be mapped.
Tip
Before using this function, you need to turn on the allowDynamicArray option
Basic Usage
Square numbers above a certain value
Find values from two columns in one row that are both TRUE
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
let initSpread = function (workbook) {
workbook.options.allowDynamicArray = true;
workbook.suspendPaint();
initSheet1(workbook.getSheet(0), getData());
workbook.resumePaint();
}
let getData = function () {
return {
values: {
1: { 1: "Examples" },
3: { 1: "Example 1: Square numbers above a vertain value" },
4: { 1: "Data:", 5: "Formula:" },
5: { 1: 1, 2: 2, 3: 3, 5: "Result:" },
6: { 1: 4, 2: 5, 3: 6 },
7: {
5: "Calculating the last LAMBDA parameter as a*1 coerces it to an integer and prevents a #CALC! error.",
},
10: { 1: "Example 2: Find values from two columns in one row that are both TRUE" },
11: { 1: "TableA:" },
12: { 1: "Col1", 2: "Col2", 5: "Formula:" },
13: { 1: false, 2: true, 5: "Result:" },
14: { 1: false, 2: true },
15: { 1: true, 2: true },
16: { 1: false, 2: false },
17: { 1: false, 2: true },
18: { 1: true, 2: false },
19: { 1: true, 2: true },
20: { 1: true, 2: false },
23: { 1: "Example 3: Find values from two columns in one row that meet certain criteria" },
24: { 1: "TableB:" },
25: { 1: "Size", 2: "Color", 5: "Formula:" },
26: { 1: "Medium", 2: "Red" },
27: { 1: "Large", 2: "Green", 6: "Valid Size", 7: "Valid Color" },
28: { 1: "Medium", 2: "Blue", 5: "Result:" },
29: { 1: "Medium", 2: "Blue" },
30: { 1: "Medium", 2: "Red" },
31: { 1: "Large", 2: "Red" },
32: { 1: "Medium", 2: "Blue" },
33: { 1: "Small", 2: "Blue" },
34: { 1: "Medium", 2: "Green" },
35: { 1: "Large", 2: "Green" },
},
formulas: {
4: { 6: "FORMULATEXT(G6)" },
5: { 6: "MAP(B6:D7,LAMBDA(a,IF(a>4,a*a,a*1)))" },
12: { 6: "FORMULATEXT(G14)" },
13: { 6: "MAP(TableA[Col1],TableA[Col2],LAMBDA(a,b,AND(a,b)))" },
25: { 6: "FORMULATEXT(G29)" },
28: { 6: 'FILTER(TableB,MAP(TableB[Size],TableB[Color],LAMBDA(s,c,AND(s="Large",c="Red"))))' },
},
cellStyles: {
"B2:C2": 0,
"B4:G4": 1,
B5: 2,
C5: 3,
D5: 4,
"F5:F6": 2,
"G5:I7": 5,
"J5:K5": 5,
"B6:D7": 6,
"F8:K9": 7,
"B11:I11": 1,
"B12:C12": 8,
"F13:F14": 2,
"G13:G21": 5,
"H13:L13": 5,
"B24:J24": 1,
"B25:C25": 8,
F26: 2,
"G26:K27": 9,
"G28:H28": 2,
F29: 2,
"G29:H29": 5,
},
styles: {
records: [
{ foreColor: 0, font: 0, border: [null, null, 0] },
{ foreColor: 0, font: 1, border: [null, null, 1] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3, 4] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, 4, 3] },
{ backColor: 4, foreColor: 3, font: 1, border: [3, 3, 3, 3] },
{ backColor: 6, foreColor: 5, border: [3, 3, 3, 3] },
{ backColor: 7, wordWrap: true, border: [5, 5, 5, 5] },
{ foreColor: 0, font: 1 },
{ backColor: 4, foreColor: 3, font: 1, wordWrap: true, border: [3, 3, 3, 3] },
],
borders: [
{ color: "#accdea", style: 5 },
{ color: "#9bc3e6", style: 2 },
{ color: "#000000", style: 1 },
{ color: "#7f7f7f", style: 1 },
{ color: "#9bc3e6", style: 1 },
{ color: "#b2b2b2", style: 1 },
],
colors: ["#44546a", "#ffffff", "#5b9bd5", "#fa7d00", "#f2f2f2", "#3f3f76", "#ffcc99", "#ffffcc"],
fonts: ["700 17.3px Calibri", "700 14.7px Calibri"],
},
others: {
columnWidth: { 0: 30 },
rowHeight: { 1: 24, 2: 21, 3: 21, 10: 21, 23: 21 },
spans: ["B5:D5", "F8:K9", "G26:K27"],
tables: [
{ name: "TableA", ref: "B13:C21" },
{ name: "TableB", ref: "B26:C36" },
],
},
};
}
let initSheet1 = function (sheet, data) {
setSheetPr(sheet, data);
setCells(sheet, data);
}
let setCells = function (sheet, data) {
foreachObj(data.values, function (r, row) {
foreachObj(row, function (c, v) {
setValue(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.formulas, function (r, row) {
foreachObj(row, function (c, v) {
setFormula(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.cellStyles, function (ref, id) {
setStyle(sheet, ref, data.styles.records[id], data.styles);
});
}
let setValue = function (sheet, r, c, v) {
if (v === undefined || v === null) return;
sheet.setValue(r, c, v);
}
let setFormula = function (sheet, r, c, v) {
if (v === undefined || v === null) return;
sheet.setFormula(r, c, v);
}
let setStyle = function (sheet, ref, v, styles) {
if (v === undefined || v === null) return;
let range = sheet.getRange(ref);
let foreColor = styles.colors[v.foreColor];
let backColor = styles.colors[v.backColor];
let font = styles.fonts[v.font];
let wordWrap = v.wordWrap;
if (foreColor) {
range.foreColor(foreColor);
}
if (backColor) {
range.backColor(backColor);
}
if (font) {
range.font(font);
}
if (wordWrap) {
range.wordWrap(wordWrap);
}
let border = v.border || [];
let borderTop = styles.borders[border[0]];
let borderRight = styles.borders[border[1]];
let borderBottom = styles.borders[border[2]];
let borderLeft = styles.borders[border[3]];
if (borderTop) {
range.borderTop(createLineStyle(borderTop));
}
if (borderBottom) {
range.borderBottom(createLineStyle(borderBottom));
}
if (borderLeft) {
range.borderLeft(createLineStyle(borderLeft));
}
if (borderRight) {
range.borderRight(createLineStyle(borderRight));
}
}
let setSheetPr = function (sheet, data) {
// set column width
foreachObj(data.others.columnWidth, function (index, v) {
sheet.setColumnWidth(Number(index), v);
});
// set row height
foreachObj(data.others.rowHeight, function (index, v) {
sheet.setRowHeight(Number(index), v);
});
// set spans
let spans = data.others.spans || [];
for (let i = 0; i < spans.length; i++) {
let range = sheet.getRange(spans[i]);
sheet.addSpan(range.row, range.col, range.rowCount, range.colCount);
}
// set tables
let tables = data.others.tables || [];
for (let i = 0; i < tables.length; i++) {
let table = tables[i];
let range = sheet.getRange(table.ref);
sheet.tables.add(table.name, range.row, range.col, range.rowCount, range.colCount);
}
}
let createLineStyle = function (v) {
return new GC.Spread.Sheets.LineBorder(v.color, v.style);
}
let foreachObj = function (obj, func) {
if (!obj) return;
let keys = Object.keys(obj);
for (let i = 0; i < keys.length; i++) {
let key = keys[i];
let v = obj[key];
func(key, v);
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Syntax
The MAP function syntax has the following arguments and parameters:
array1
An array to be mapped.
lambdaorarray<#>
A LAMBDA which must be the last argument and which must have either a parameter for each array passed, or another array to be mapped.
Tip
Before using this function, you need to turn on the allowDynamicArray option
Basic Usage
Square numbers above a certain value
Find values from two columns in one row that are both TRUE
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from "react";
import { SpreadSheets, Worksheet } from "@mescius/spread-sheets-react";
import GC from "@mescius/spread-sheets";
import "./styles.css";
const data = {
values: {
1: { 1: "Examples" },
3: { 1: "Example 1: Square numbers above a vertain value" },
4: { 1: "Data:", 5: "Formula:" },
5: { 1: 1, 2: 2, 3: 3, 5: "Result:" },
6: { 1: 4, 2: 5, 3: 6 },
7: {
5: "Calculating the last LAMBDA parameter as a*1 coerces it to an integer and prevents a #CALC! error.",
},
10: { 1: "Example 2: Find values from two columns in one row that are both TRUE" },
11: { 1: "TableA:" },
12: { 1: "Col1", 2: "Col2", 5: "Formula:" },
13: { 1: false, 2: true, 5: "Result:" },
14: { 1: false, 2: true },
15: { 1: true, 2: true },
16: { 1: false, 2: false },
17: { 1: false, 2: true },
18: { 1: true, 2: false },
19: { 1: true, 2: true },
20: { 1: true, 2: false },
23: { 1: "Example 3: Find values from two columns in one row that meet certain criteria" },
24: { 1: "TableB:" },
25: { 1: "Size", 2: "Color", 5: "Formula:" },
26: { 1: "Medium", 2: "Red" },
27: { 1: "Large", 2: "Green", 6: "Valid Size", 7: "Valid Color" },
28: { 1: "Medium", 2: "Blue", 5: "Result:" },
29: { 1: "Medium", 2: "Blue" },
30: { 1: "Medium", 2: "Red" },
31: { 1: "Large", 2: "Red" },
32: { 1: "Medium", 2: "Blue" },
33: { 1: "Small", 2: "Blue" },
34: { 1: "Medium", 2: "Green" },
35: { 1: "Large", 2: "Green" },
},
formulas: {
4: { 6: "FORMULATEXT(G6)" },
5: { 6: "MAP(B6:D7,LAMBDA(a,IF(a>4,a*a,a*1)))" },
12: { 6: "FORMULATEXT(G14)" },
13: { 6: "MAP(TableA[Col1],TableA[Col2],LAMBDA(a,b,AND(a,b)))" },
25: { 6: "FORMULATEXT(G29)" },
28: { 6: 'FILTER(TableB,MAP(TableB[Size],TableB[Color],LAMBDA(s,c,AND(s="Large",c="Red"))))' },
},
cellStyles: {
"B2:C2": 0,
"B4:G4": 1,
B5: 2,
C5: 3,
D5: 4,
"F5:F6": 2,
"G5:I7": 5,
"J5:K5": 5,
"B6:D7": 6,
"F8:K9": 7,
"B11:I11": 1,
"B12:C12": 8,
"F13:F14": 2,
"G13:G21": 5,
"H13:L13": 5,
"B24:J24": 1,
"B25:C25": 8,
F26: 2,
"G26:K27": 9,
"G28:H28": 2,
F29: 2,
"G29:H29": 5,
},
styles: {
records: [
{ foreColor: 0, font: 0, border: [null, null, 0] },
{ foreColor: 0, font: 1, border: [null, null, 1] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3, 4] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, 4, 3] },
{ backColor: 4, foreColor: 3, font: 1, border: [3, 3, 3, 3] },
{ backColor: 6, foreColor: 5, border: [3, 3, 3, 3] },
{ backColor: 7, wordWrap: true, border: [5, 5, 5, 5] },
{ foreColor: 0, font: 1 },
{ backColor: 4, foreColor: 3, font: 1, wordWrap: true, border: [3, 3, 3, 3] },
],
borders: [
{ color: "#accdea", style: 5 },
{ color: "#9bc3e6", style: 2 },
{ color: "#000000", style: 1 },
{ color: "#7f7f7f", style: 1 },
{ color: "#9bc3e6", style: 1 },
{ color: "#b2b2b2", style: 1 },
],
colors: ["#44546a", "#ffffff", "#5b9bd5", "#fa7d00", "#f2f2f2", "#3f3f76", "#ffcc99", "#ffffcc"],
fonts: ["700 17.3px Calibri", "700 14.7px Calibri"],
},
others: {
columnWidth: { 0: 30 },
rowHeight: { 1: 24, 2: 21, 3: 21, 10: 21, 23: 21 },
spans: ["B5:D5", "F8:K9", "G26:K27"],
tables: [
{ name: "TableA", ref: "B13:C21" },
{ name: "TableB", ref: "B26:C36" },
],
},
};
export function AppFunc() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={(spread) => initWorkbook(spread, data)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
</div>
);
}
function initWorkbook(workbook, data) {
workbook.options.allowDynamicArray = true;
workbook.suspendPaint();
initSheet1(workbook.getSheet(0), data);
workbook.resumePaint();
}
function initSheet1(sheet, data) {
setSheetPr(sheet, data);
setCells(sheet, data);
}
function setCells(sheet, data) {
foreachObj(data.values, function (r, row) {
foreachObj(row, function (c, v) {
setValue(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.formulas, function (r, row) {
foreachObj(row, function (c, v) {
setFormula(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.cellStyles, function (ref, id) {
setStyle(sheet, ref, data.styles.records[id], data.styles);
});
}
function setValue(sheet, r, c, v) {
if (v === undefined || v === null) return;
sheet.setValue(r, c, v);
}
function setFormula(sheet, r, c, v) {
if (v === undefined || v === null) return;
sheet.setFormula(r, c, v);
}
function setStyle(sheet, ref, v, styles) {
if (v === undefined || v === null) return;
var range = sheet.getRange(ref);
var foreColor = styles.colors[v.foreColor];
var backColor = styles.colors[v.backColor];
var font = styles.fonts[v.font];
var wordWrap = v.wordWrap;
if (foreColor) {
range.foreColor(foreColor);
}
if (backColor) {
range.backColor(backColor);
}
if (font) {
range.font(font);
}
if (wordWrap) {
range.wordWrap(wordWrap);
}
var border = v.border || [];
var borderTop = styles.borders[border[0]];
var borderRight = styles.borders[border[1]];
var borderBottom = styles.borders[border[2]];
var borderLeft = styles.borders[border[3]];
if (borderTop) {
range.borderTop(createLineStyle(borderTop));
}
if (borderBottom) {
range.borderBottom(createLineStyle(borderBottom));
}
if (borderLeft) {
range.borderLeft(createLineStyle(borderLeft));
}
if (borderRight) {
range.borderRight(createLineStyle(borderRight));
}
}
function setSheetPr(sheet, data) {
// set column width
foreachObj(data.others.columnWidth, function (index, v) {
sheet.setColumnWidth(Number(index), v);
});
// set row height
foreachObj(data.others.rowHeight, function (index, v) {
sheet.setRowHeight(Number(index), v);
});
// set spans
var spans = data.others.spans || [];
for (var i = 0; i < spans.length; i++) {
var range = sheet.getRange(spans[i]);
sheet.addSpan(range.row, range.col, range.rowCount, range.colCount);
}
// set tables
var tables = data.others.tables || [];
for (var i = 0; i < tables.length; i++) {
var table = tables[i];
var range = sheet.getRange(table.ref);
sheet.tables.add(table.name, range.row, range.col, range.rowCount, range.colCount);
}
}
function createLineStyle(v) {
return new GC.Spread.Sheets.LineBorder(v.color, v.style);
}
function foreachObj(obj, func) {
if (!obj) return;
var keys = Object.keys(obj);
for (var i = 0; i < keys.length; i++) {
var key = keys[i];
var v = obj[key];
func(key, v);
}
}
import * as React from "react";
import { SpreadSheets, Worksheet } from "@mescius/spread-sheets-react";
import GC from "@mescius/spread-sheets";
import "./styles.css";
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.data = {
values: {
1: { 1: "Examples" },
3: { 1: "Example 1: Square numbers above a vertain value" },
4: { 1: "Data:", 5: "Formula:" },
5: { 1: 1, 2: 2, 3: 3, 5: "Result:" },
6: { 1: 4, 2: 5, 3: 6 },
7: {
5: "Calculating the last LAMBDA parameter as a*1 coerces it to an integer and prevents a #CALC! error.",
},
10: { 1: "Example 2: Find values from two columns in one row that are both TRUE" },
11: { 1: "TableA:" },
12: { 1: "Col1", 2: "Col2", 5: "Formula:" },
13: { 1: false, 2: true, 5: "Result:" },
14: { 1: false, 2: true },
15: { 1: true, 2: true },
16: { 1: false, 2: false },
17: { 1: false, 2: true },
18: { 1: true, 2: false },
19: { 1: true, 2: true },
20: { 1: true, 2: false },
23: { 1: "Example 3: Find values from two columns in one row that meet certain criteria" },
24: { 1: "TableB:" },
25: { 1: "Size", 2: "Color", 5: "Formula:" },
26: { 1: "Medium", 2: "Red" },
27: { 1: "Large", 2: "Green", 6: "Valid Size", 7: "Valid Color" },
28: { 1: "Medium", 2: "Blue", 5: "Result:" },
29: { 1: "Medium", 2: "Blue" },
30: { 1: "Medium", 2: "Red" },
31: { 1: "Large", 2: "Red" },
32: { 1: "Medium", 2: "Blue" },
33: { 1: "Small", 2: "Blue" },
34: { 1: "Medium", 2: "Green" },
35: { 1: "Large", 2: "Green" },
},
formulas: {
4: { 6: "FORMULATEXT(G6)" },
5: { 6: "MAP(B6:D7,LAMBDA(a,IF(a>4,a*a,a*1)))" },
12: { 6: "FORMULATEXT(G14)" },
13: { 6: "MAP(TableA[Col1],TableA[Col2],LAMBDA(a,b,AND(a,b)))" },
25: { 6: "FORMULATEXT(G29)" },
28: { 6: 'FILTER(TableB,MAP(TableB[Size],TableB[Color],LAMBDA(s,c,AND(s="Large",c="Red"))))' },
},
cellStyles: {
"B2:C2": 0,
"B4:G4": 1,
B5: 2,
C5: 3,
D5: 4,
"F5:F6": 2,
"G5:I7": 5,
"J5:K5": 5,
"B6:D7": 6,
"F8:K9": 7,
"B11:I11": 1,
"B12:C12": 8,
"F13:F14": 2,
"G13:G21": 5,
"H13:L13": 5,
"B24:J24": 1,
"B25:C25": 8,
F26: 2,
"G26:K27": 9,
"G28:H28": 2,
F29: 2,
"G29:H29": 5,
},
styles: {
records: [
{ foreColor: 0, font: 0, border: [null, null, 0] },
{ foreColor: 0, font: 1, border: [null, null, 1] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3, 4] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, 4, 3] },
{ backColor: 4, foreColor: 3, font: 1, border: [3, 3, 3, 3] },
{ backColor: 6, foreColor: 5, border: [3, 3, 3, 3] },
{ backColor: 7, wordWrap: true, border: [5, 5, 5, 5] },
{ foreColor: 0, font: 1 },
{ backColor: 4, foreColor: 3, font: 1, wordWrap: true, border: [3, 3, 3, 3] },
],
borders: [
{ color: "#accdea", style: 5 },
{ color: "#9bc3e6", style: 2 },
{ color: "#000000", style: 1 },
{ color: "#7f7f7f", style: 1 },
{ color: "#9bc3e6", style: 1 },
{ color: "#b2b2b2", style: 1 },
],
colors: ["#44546a", "#ffffff", "#5b9bd5", "#fa7d00", "#f2f2f2", "#3f3f76", "#ffcc99", "#ffffcc"],
fonts: ["700 17.3px Calibri", "700 14.7px Calibri"],
},
others: {
columnWidth: { 0: 30 },
rowHeight: { 1: 24, 2: 21, 3: 21, 10: 21, 23: 21 },
spans: ["B5:D5", "F8:K9", "G26:K27"],
tables: [
{ name: "TableA", ref: "B13:C21" },
{ name: "TableB", ref: "B26:C36" },
],
},
};
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={(spread) => initWorkbook(spread, this.data)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
</div>
);
}
}
function initWorkbook(workbook, data) {
workbook.options.allowDynamicArray = true;
workbook.suspendPaint();
initSheet1(workbook.getSheet(0), data);
workbook.resumePaint();
}
function initSheet1(sheet, data) {
setSheetPr(sheet, data);
setCells(sheet, data);
}
function setCells(sheet, data) {
foreachObj(data.values, function (r, row) {
foreachObj(row, function (c, v) {
setValue(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.formulas, function (r, row) {
foreachObj(row, function (c, v) {
setFormula(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.cellStyles, function (ref, id) {
setStyle(sheet, ref, data.styles.records[id], data.styles);
});
}
function setValue(sheet, r, c, v) {
if (v === undefined || v === null) return;
sheet.setValue(r, c, v);
}
function setFormula(sheet, r, c, v) {
if (v === undefined || v === null) return;
sheet.setFormula(r, c, v);
}
function setStyle(sheet, ref, v, styles) {
if (v === undefined || v === null) return;
var range = sheet.getRange(ref);
var foreColor = styles.colors[v.foreColor];
var backColor = styles.colors[v.backColor];
var font = styles.fonts[v.font];
var wordWrap = v.wordWrap;
if (foreColor) {
range.foreColor(foreColor);
}
if (backColor) {
range.backColor(backColor);
}
if (font) {
range.font(font);
}
if (wordWrap) {
range.wordWrap(wordWrap);
}
var border = v.border || [];
var borderTop = styles.borders[border[0]];
var borderRight = styles.borders[border[1]];
var borderBottom = styles.borders[border[2]];
var borderLeft = styles.borders[border[3]];
if (borderTop) {
range.borderTop(createLineStyle(borderTop));
}
if (borderBottom) {
range.borderBottom(createLineStyle(borderBottom));
}
if (borderLeft) {
range.borderLeft(createLineStyle(borderLeft));
}
if (borderRight) {
range.borderRight(createLineStyle(borderRight));
}
}
function setSheetPr(sheet, data) {
// set column width
foreachObj(data.others.columnWidth, function (index, v) {
sheet.setColumnWidth(Number(index), v);
});
// set row height
foreachObj(data.others.rowHeight, function (index, v) {
sheet.setRowHeight(Number(index), v);
});
// set spans
var spans = data.others.spans || [];
for (var i = 0; i < spans.length; i++) {
var range = sheet.getRange(spans[i]);
sheet.addSpan(range.row, range.col, range.rowCount, range.colCount);
}
// set tables
var tables = data.others.tables || [];
for (var i = 0; i < tables.length; i++) {
var table = tables[i];
var range = sheet.getRange(table.ref);
sheet.tables.add(table.name, range.row, range.col, range.rowCount, range.colCount);
}
}
function createLineStyle(v) {
return new GC.Spread.Sheets.LineBorder(v.color, v.style);
}
function foreachObj(obj, func) {
if (!obj) return;
var keys = Object.keys(obj);
for (var i = 0; i < keys.length; i++) {
var key = keys[i];
var v = obj[key];
func(key, v);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
input {
padding: 4px 6px;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Syntax
The MAP function syntax has the following arguments and parameters:
array1
An array to be mapped.
lambdaorarray<#>
A LAMBDA which must be the last argument and which must have either a parameter for each array passed, or another array to be mapped.
Tip
Before using this function, you need to turn on the allowDynamicArray option
Basic Usage
Square numbers above a certain value
Find values from two columns in one row that are both TRUE
import { Component, NgModule, enableProdMode } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import { FormsModule } from "@angular/forms";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { SpreadSheetsModule } from "@mescius/spread-sheets-angular";
import GC from "@mescius/spread-sheets";
import "./styles.css";
const spreadNS = GC.Spread.Sheets,
SheetArea = spreadNS.SheetArea;
@Component({
selector: "app-component",
templateUrl: "src/app.component.html",
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: "100%",
height: "100%",
overflow: "hidden",
float: "left",
};
data = {
values: {
"1": { "1": "Examples" },
"3": { "1": "Example 1: Square numbers above a vertain value" },
"4": { "1": "Data:", "5": "Formula:" },
"5": { "1": 1, "2": 2, "3": 3, "5": "Result:" },
"6": { "1": 4, "2": 5, "3": 6 },
"7": {
"5": "Calculating the last LAMBDA parameter as a*1 coerces it to an integer and prevents a #CALC! error.",
},
"10": { "1": "Example 2: Find values from two columns in one row that are both TRUE" },
"11": { "1": "TableA:" },
"12": { "1": "Col1", "2": "Col2", "5": "Formula:" },
"13": { "1": false, "2": true, "5": "Result:" },
"14": { "1": false, "2": true },
"15": { "1": true, "2": true },
"16": { "1": false, "2": false },
"17": { "1": false, "2": true },
"18": { "1": true, "2": false },
"19": { "1": true, "2": true },
"20": { "1": true, "2": false },
"23": { "1": "Example 3: Find values from two columns in one row that meet certain criteria" },
"24": { "1": "TableB:" },
"25": { "1": "Size", "2": "Color", "5": "Formula:" },
"26": { "1": "Medium", "2": "Red" },
"27": { "1": "Large", "2": "Green", "6": "Valid Size", "7": "Valid Color" },
"28": { "1": "Medium", "2": "Blue", "5": "Result:" },
"29": { "1": "Medium", "2": "Blue" },
"30": { "1": "Medium", "2": "Red" },
"31": { "1": "Large", "2": "Red" },
"32": { "1": "Medium", "2": "Blue" },
"33": { "1": "Small", "2": "Blue" },
"34": { "1": "Medium", "2": "Green" },
"35": { "1": "Large", "2": "Green" },
},
formulas: {
"4": { "6": "FORMULATEXT(G6)" },
"5": { "6": "MAP(B6:D7,LAMBDA(a,IF(a>4,a*a,a*1)))" },
"12": { "6": "FORMULATEXT(G14)" },
"13": { "6": "MAP(TableA[Col1],TableA[Col2],LAMBDA(a,b,AND(a,b)))" },
"25": { "6": "FORMULATEXT(G29)" },
"28": { "6": 'FILTER(TableB,MAP(TableB[Size],TableB[Color],LAMBDA(s,c,AND(s="Large",c="Red"))))' },
},
cellStyles: {
"B2:C2": 0,
"B4:G4": 1,
B5: 2,
C5: 3,
D5: 4,
"F5:F6": 2,
"G5:I7": 5,
"J5:K5": 5,
"B6:D7": 6,
"F8:K9": 7,
"B11:I11": 1,
"B12:C12": 8,
"F13:F14": 2,
"G13:G21": 5,
"H13:L13": 5,
"B24:J24": 1,
"B25:C25": 8,
F26: 2,
"G26:K27": 9,
"G28:H28": 2,
F29: 2,
"G29:H29": 5,
},
styles: {
records: [
{ foreColor: 0, font: 0, border: [null, null, 0] },
{ foreColor: 0, font: 1, border: [null, null, 1] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3, 4] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, null, 3] },
{ backColor: 2, foreColor: 1, font: 1, border: [2, 4, 3] },
{ backColor: 4, foreColor: 3, font: 1, border: [3, 3, 3, 3] },
{ backColor: 6, foreColor: 5, border: [3, 3, 3, 3] },
{ backColor: 7, wordWrap: true, border: [5, 5, 5, 5] },
{ foreColor: 0, font: 1 },
{ backColor: 4, foreColor: 3, font: 1, wordWrap: true, border: [3, 3, 3, 3] },
],
borders: [
{ color: "#accdea", style: 5 },
{ color: "#9bc3e6", style: 2 },
{ color: "#000000", style: 1 },
{ color: "#7f7f7f", style: 1 },
{ color: "#9bc3e6", style: 1 },
{ color: "#b2b2b2", style: 1 },
],
colors: ["#44546a", "#ffffff", "#5b9bd5", "#fa7d00", "#f2f2f2", "#3f3f76", "#ffcc99", "#ffffcc"],
fonts: ["700 17.3px Calibri", "700 14.7px Calibri"],
},
others: {
columnWidth: { "0": 30 },
rowHeight: { "1": 24, "2": 21, "3": 21, "10": 21, "23": 21 },
spans: ["B5:D5", "F8:K9", "G26:K27"],
tables: [
{ name: "TableA", ref: "B13:C21" },
{ name: "TableB", ref: "B26:C36" },
],
},
};
constructor() {}
init($event: any) {
let workbook = (this.spread = $event.spread);
initWorkbook(workbook, this.data);
}
}
function initWorkbook(workbook: GC.Spread.Sheets.Workbook, data: any) {
workbook.options.allowDynamicArray = true;
workbook.suspendPaint();
initSheet1(workbook.getSheet(0), data);
workbook.resumePaint();
}
function initSheet1(sheet: GC.Spread.Sheets.Worksheet, data: any) {
setSheetPr(sheet, data);
setCells(sheet, data);
}
function setCells(sheet: GC.Spread.Sheets.Worksheet, data: any) {
foreachObj(data.values, function (r: string, row: any) {
foreachObj(row, function (c: string, v: any) {
setValue(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.formulas, function (r: string, row: any) {
foreachObj(row, function (c: string, v: any) {
setFormula(sheet, Number(r), Number(c), v);
});
});
foreachObj(data.cellStyles, function (ref: string, id: number) {
setStyle(sheet, ref, data.styles.records[id], data.styles);
});
}
function setValue(sheet: GC.Spread.Sheets.Worksheet, r: number, c: number, v: any) {
if (v === undefined || v === null) return;
sheet.setValue(r, c, v);
}
function setFormula(sheet: GC.Spread.Sheets.Worksheet, r: number, c: number, v: string) {
if (v === undefined || v === null) return;
sheet.setFormula(r, c, v);
}
function setStyle(sheet: GC.Spread.Sheets.Worksheet, ref: string, v: any, styles: any) {
if (v === undefined || v === null) return;
var range = sheet.getRange(ref);
var foreColor = styles.colors[v.foreColor];
var backColor = styles.colors[v.backColor];
var font = styles.fonts[v.font];
var wordWrap = v.wordWrap;
if (foreColor) {
range.foreColor(foreColor);
}
if (backColor) {
range.backColor(backColor);
}
if (font) {
range.font(font);
}
if (wordWrap) {
range.wordWrap(wordWrap);
}
var border = v.border || [];
var borderTop = styles.borders[border[0]];
var borderRight = styles.borders[border[1]];
var borderBottom = styles.borders[border[2]];
var borderLeft = styles.borders[border[3]];
if (borderTop) {
range.borderTop(createLineStyle(borderTop));
}
if (borderBottom) {
range.borderBottom(createLineStyle(borderBottom));
}
if (borderLeft) {
range.borderLeft(createLineStyle(borderLeft));
}
if (borderRight) {
range.borderRight(createLineStyle(borderRight));
}
}
function setSheetPr(sheet: GC.Spread.Sheets.Worksheet, data: any) {
// set column width
foreachObj(data.others.columnWidth, function (index: string, v: any) {
sheet.setColumnWidth(Number(index), v);
});
// set row height
foreachObj(data.others.rowHeight, function (index: string, v: any) {
sheet.setRowHeight(Number(index), v);
});
// set spans
var spans = data.others.spans || [];
for (var i = 0; i < spans.length; i++) {
var range = sheet.getRange(spans[i]);
sheet.addSpan(range.row, range.col, range.rowCount, range.colCount);
}
// set tables
var tables = data.others.tables || [];
for (var i = 0; i < tables.length; i++) {
var table = tables[i];
var range = sheet.getRange(table.ref);
sheet.tables.add(table.name, range.row, range.col, range.rowCount, range.colCount);
}
}
function createLineStyle(v: any) {
return new GC.Spread.Sheets.LineBorder(v.color, v.style);
}
function foreachObj(obj: any, func: Function) {
if (!obj) return;
var keys = Object.keys(obj);
for (var i = 0; i < keys.length; i++) {
var key = keys[i];
var v = obj[key];
func(key, v);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="init($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
display: inline-block;
}
input[type="text"] {
width: 200px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);